/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the SubscriptionMutable type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SubscriptionMutable{}

// SubscriptionMutable struct for SubscriptionMutable
type SubscriptionMutable struct {
	Category *NotificationCategory `json:"category,omitempty"`
	Channel *NotificationChannel `json:"channel,omitempty"`
	MinSeverity *NotificationSeverity `json:"min_severity,omitempty"`
	Frequency *NotificationFrequency `json:"frequency,omitempty"`
	Muted *bool `json:"muted,omitempty"`
}

// NewSubscriptionMutable instantiates a new SubscriptionMutable object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSubscriptionMutable() *SubscriptionMutable {
	this := SubscriptionMutable{}
	return &this
}

// NewSubscriptionMutableWithDefaults instantiates a new SubscriptionMutable object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSubscriptionMutableWithDefaults() *SubscriptionMutable {
	this := SubscriptionMutable{}
	return &this
}

// GetCategory returns the Category field value if set, zero value otherwise.
func (o *SubscriptionMutable) GetCategory() NotificationCategory {
	if o == nil || IsNil(o.Category) {
		var ret NotificationCategory
		return ret
	}
	return *o.Category
}

// GetCategoryOk returns a tuple with the Category field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SubscriptionMutable) GetCategoryOk() (*NotificationCategory, bool) {
	if o == nil || IsNil(o.Category) {
		return nil, false
	}
	return o.Category, true
}

// HasCategory returns a boolean if a field has been set.
func (o *SubscriptionMutable) HasCategory() bool {
	if o != nil && !IsNil(o.Category) {
		return true
	}

	return false
}

// SetCategory gets a reference to the given NotificationCategory and assigns it to the Category field.
func (o *SubscriptionMutable) SetCategory(v NotificationCategory) {
	o.Category = &v
}

// GetChannel returns the Channel field value if set, zero value otherwise.
func (o *SubscriptionMutable) GetChannel() NotificationChannel {
	if o == nil || IsNil(o.Channel) {
		var ret NotificationChannel
		return ret
	}
	return *o.Channel
}

// GetChannelOk returns a tuple with the Channel field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SubscriptionMutable) GetChannelOk() (*NotificationChannel, bool) {
	if o == nil || IsNil(o.Channel) {
		return nil, false
	}
	return o.Channel, true
}

// HasChannel returns a boolean if a field has been set.
func (o *SubscriptionMutable) HasChannel() bool {
	if o != nil && !IsNil(o.Channel) {
		return true
	}

	return false
}

// SetChannel gets a reference to the given NotificationChannel and assigns it to the Channel field.
func (o *SubscriptionMutable) SetChannel(v NotificationChannel) {
	o.Channel = &v
}

// GetMinSeverity returns the MinSeverity field value if set, zero value otherwise.
func (o *SubscriptionMutable) GetMinSeverity() NotificationSeverity {
	if o == nil || IsNil(o.MinSeverity) {
		var ret NotificationSeverity
		return ret
	}
	return *o.MinSeverity
}

// GetMinSeverityOk returns a tuple with the MinSeverity field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SubscriptionMutable) GetMinSeverityOk() (*NotificationSeverity, bool) {
	if o == nil || IsNil(o.MinSeverity) {
		return nil, false
	}
	return o.MinSeverity, true
}

// HasMinSeverity returns a boolean if a field has been set.
func (o *SubscriptionMutable) HasMinSeverity() bool {
	if o != nil && !IsNil(o.MinSeverity) {
		return true
	}

	return false
}

// SetMinSeverity gets a reference to the given NotificationSeverity and assigns it to the MinSeverity field.
func (o *SubscriptionMutable) SetMinSeverity(v NotificationSeverity) {
	o.MinSeverity = &v
}

// GetFrequency returns the Frequency field value if set, zero value otherwise.
func (o *SubscriptionMutable) GetFrequency() NotificationFrequency {
	if o == nil || IsNil(o.Frequency) {
		var ret NotificationFrequency
		return ret
	}
	return *o.Frequency
}

// GetFrequencyOk returns a tuple with the Frequency field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SubscriptionMutable) GetFrequencyOk() (*NotificationFrequency, bool) {
	if o == nil || IsNil(o.Frequency) {
		return nil, false
	}
	return o.Frequency, true
}

// HasFrequency returns a boolean if a field has been set.
func (o *SubscriptionMutable) HasFrequency() bool {
	if o != nil && !IsNil(o.Frequency) {
		return true
	}

	return false
}

// SetFrequency gets a reference to the given NotificationFrequency and assigns it to the Frequency field.
func (o *SubscriptionMutable) SetFrequency(v NotificationFrequency) {
	o.Frequency = &v
}

// GetMuted returns the Muted field value if set, zero value otherwise.
func (o *SubscriptionMutable) GetMuted() bool {
	if o == nil || IsNil(o.Muted) {
		var ret bool
		return ret
	}
	return *o.Muted
}

// GetMutedOk returns a tuple with the Muted field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SubscriptionMutable) GetMutedOk() (*bool, bool) {
	if o == nil || IsNil(o.Muted) {
		return nil, false
	}
	return o.Muted, true
}

// HasMuted returns a boolean if a field has been set.
func (o *SubscriptionMutable) HasMuted() bool {
	if o != nil && !IsNil(o.Muted) {
		return true
	}

	return false
}

// SetMuted gets a reference to the given bool and assigns it to the Muted field.
func (o *SubscriptionMutable) SetMuted(v bool) {
	o.Muted = &v
}

func (o SubscriptionMutable) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SubscriptionMutable) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Category) {
		toSerialize["category"] = o.Category
	}
	if !IsNil(o.Channel) {
		toSerialize["channel"] = o.Channel
	}
	if !IsNil(o.MinSeverity) {
		toSerialize["min_severity"] = o.MinSeverity
	}
	if !IsNil(o.Frequency) {
		toSerialize["frequency"] = o.Frequency
	}
	if !IsNil(o.Muted) {
		toSerialize["muted"] = o.Muted
	}
	return toSerialize, nil
}

type NullableSubscriptionMutable struct {
	value *SubscriptionMutable
	isSet bool
}

func (v NullableSubscriptionMutable) Get() *SubscriptionMutable {
	return v.value
}

func (v *NullableSubscriptionMutable) Set(val *SubscriptionMutable) {
	v.value = val
	v.isSet = true
}

func (v NullableSubscriptionMutable) IsSet() bool {
	return v.isSet
}

func (v *NullableSubscriptionMutable) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSubscriptionMutable(val *SubscriptionMutable) *NullableSubscriptionMutable {
	return &NullableSubscriptionMutable{value: val, isSet: true}
}

func (v NullableSubscriptionMutable) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSubscriptionMutable) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


